/*********************************************************************************/
/********** THIS FILE IS GENERATED BY TOUCHGFX DESIGNER, DO NOT MODIFY ***********/
/*********************************************************************************/
#ifndef GRAPH_VIEW_BASE_HPP
#define GRAPH_VIEW_BASE_HPP

#include <gui/common/FrontendApplication.hpp>
#include <mvp/View.hpp>
#include <gui/graph_screen/GraphPresenter.hpp>
#include <touchgfx/containers/Container.hpp>
#include <touchgfx/widgets/Box.hpp>

#include <touchgfx/widgets/Image.hpp>
#include <touchgfx/widgets/Button.hpp>
#include <touchgfx/widgets/ToggleButton.hpp>
#include <gui/containers/mcuLoadWidget.hpp>
class GraphViewBase : public touchgfx::View<GraphPresenter>
{
public:
    GraphViewBase();
    virtual ~GraphViewBase() {}

    virtual void setupScreen();

    /*
     * Custom Action Handlers
     */
    virtual void updateGraphSettings()
    {
        // Override and implement this function in GraphView
    }

    virtual void newButtonPressed()
    {
        // Override and implement this function in GraphView
    }

    virtual void graphOrPieButtonPressed()
    {
        // Override and implement this function in GraphView
    }

    virtual void donutOrPieButtonPressed()
    {
        // Override and implement this function in GraphView
    }

protected:
    FrontendApplication& application() {
        return *static_cast<FrontendApplication*>(Application::getInstance());
    }

    /*
     * Member Declarations
     */
    touchgfx::Container graphArea;
    touchgfx::Box graphBackground;

    touchgfx::Image backgroundBottom;
    touchgfx::Button newButton;
    touchgfx::Button graphOrPieButton;
    touchgfx::Button donutOrPieButton;
    touchgfx::Container topMenuContainer;
    touchgfx::Box topMenuBackground;
    touchgfx::ToggleButton primaryGraphLineSetting;
    touchgfx::ToggleButton primaryGraphDotSetting;
    touchgfx::ToggleButton primaryGraphAreaSetting;
    touchgfx::ToggleButton secondaryGraphLineSetting;
    touchgfx::ToggleButton secondaryGraphDotSetting;
    touchgfx::ToggleButton secondaryGraphAreaSetting;

    touchgfx::Button gotoMenu;
    McuLoadWidget mcuLoad;

private:

    /*
     * Callback Handler Declarations
     */
    void buttonCallbackHandler(const touchgfx::AbstractButton& src);

    /*
     * Callback Declarations
     */
    touchgfx::Callback<GraphViewBase, const touchgfx::AbstractButton&> buttonCallback;

};

#endif // GRAPH_VIEW_BASE_HPP
